#include "DestroyMsg.h"

namespace RoboidControl {

DestroyMsg::DestroyMsg(unsigned char networkId, Thing* thing) {
  this->networkId = networkId;
  this->thingId = thing->id;
}

DestroyMsg::DestroyMsg(char* buffer) {
  this->networkId = buffer[1];
  this->thingId = buffer[2];
}

DestroyMsg::~DestroyMsg() {}

unsigned char DestroyMsg::Serialize(char* buffer) {
#if defined(DEBUG)
  std::cout << "Send DestroyMsg [" << (int)this->networkId << "/"
            << (int)this->thingId << "] " << std::endl;
#endif
  unsigned char ix = 0;
  buffer[ix++] = this->id;
  buffer[ix++] = this->networkId;
  buffer[ix++] = this->thingId;
  return ix;
}

}  // namespace RoboidControl
