#pragma once

#include "LinearAlgebra/Spherical.h"
#include "LinearAlgebra/SwingTwist.h"

namespace RoboidControl {

class LowLevelMessages {
 public:
  static void SendSpherical(char* buffer, unsigned char* ix, Spherical s);
  static Spherical ReceiveSpherical(const char* buffer,
                                    unsigned char* startIndex);

  static void SendQuat32(char* buffer, unsigned char* ix, SwingTwist q);
  static SwingTwist ReceiveQuat32(const char* buffer, unsigned char* ix);

  static void SendAngle8(char* buffer, unsigned char* ix, const float angle);
  static Angle8 ReceiveAngle8(const char* buffer, unsigned char* startIndex);

  static void SendFloat16(char* buffer, unsigned char* ix, float value);
  static float ReceiveFloat16(const char* buffer, unsigned char* startIndex);
};

}  // namespace RoboidControl
