#if GTEST

// #include <gmock/gmock.h>
// not supported using Visual Studio 2022 compiler...
#include <gtest/gtest.h>

#include "Participants/SiteServer.h"
#include "Thing.h"

#include <chrono>
#include <thread>

using namespace RoboidControl;

TEST(Participant, Participant) {
  ParticipantUDP* participant = new ParticipantUDP("127.0.0.1", 7682);

  unsigned long milliseconds = Thing::GetTimeMs();
  unsigned long startTime = milliseconds;
  while (milliseconds < startTime + 7000) {
    participant->Update();
    
    std::this_thread::sleep_for(std::chrono::milliseconds(100));
    milliseconds = Thing::GetTimeMs();
  }
  SUCCEED();
}

TEST(Participant, SiteServer) {
  SiteServer* siteServer = new SiteServer();

  unsigned long milliseconds = Thing::GetTimeMs();
  unsigned long startTime = milliseconds;
  while (milliseconds < startTime + 7000) {
    siteServer->Update();
    
    std::this_thread::sleep_for(std::chrono::milliseconds(100));
    milliseconds = Thing::GetTimeMs();
  }
  SUCCEED();
}

TEST(Participant, SiteParticipant) {
  SiteServer* siteServer = new SiteServer(7681);
  ParticipantUDP* participant = new ParticipantUDP("127.0.0.1", 7681, 7682);

  unsigned long milliseconds = Thing::GetTimeMs();
  unsigned long startTime = milliseconds;
  while (milliseconds < startTime + 7000) {
    siteServer->Update();
    participant->Update();

    std::this_thread::sleep_for(std::chrono::milliseconds(100));
    milliseconds = Thing::GetTimeMs();
  }
  SUCCEED();
}

TEST(Participant, ThingMsg) {
  SiteServer* siteServer = new SiteServer(7681);
  ParticipantUDP* participant = new ParticipantUDP("127.0.0.1", 7681, 7682);
  Thing* thing = new Thing();
  thing->SetName("First Thing");
  thing->SetModel("https://passer.life/extras/ant.jpg");
  
  unsigned long milliseconds = Thing::GetTimeMs();
  unsigned long startTime = milliseconds;
  while (milliseconds < startTime + 7000) {
    siteServer->Update();
    participant->Update();

    std::this_thread::sleep_for(std::chrono::milliseconds(100));
    milliseconds = Thing::GetTimeMs();
  }
  SUCCEED();
}

#endif
